import grok
from grok import index
from interfaces import IUniversity, IFaculty, IStudent

class University(grok.Application, grok.Container):
    grok.implements(IUniversity)

    def __init__(self, name=u'Unnamed', **kw):
        super(University, self).__init__(**kw)
        self.name = name

class Index(grok.View):
    grok.context(University)

    def getFacList(self):
        return [x for x in self.context.values()
                if IFaculty.providedBy(x)]

class Edit(grok.EditForm):
    grok.context(University)
    grok.AutoFields(IUniversity)

class AddFaculty(grok.AddForm):
    grok.context(IUniversity)
    form_fields = grok.AutoFields(IFaculty)

    @grok.action('Add Faculty')
    def addFaculty(self, name, *args, **kw):
        new_fac = Faculty(name=name)
        self.context[name] = new_fac
        self.redirect(self.url(new_fac))

class Faculty(grok.Container):
    grok.implements(IFaculty)

    def __init__(self, name=u'Unnamed Faculty', **kw):
        super(Faculty, self).__init__(**kw)
        self.name = name

class FacIndex(grok.DisplayForm):
    grok.context(Faculty)
    grok.name('index')
    form_fields = grok.AutoFields(IFaculty)


