from __future__ import with_statement
import sys
import csv
import random
from datetime import datetime
import os
import grok
from grok import index
from hurry.query.query import Query, Text
from hurry.query import Eq
from interfaces import IStudent
from app import University
from student import Student

class StudentIndexes(grok.Indexes):
     grok.site(University)
     grok.name('students_catalog')
     grok.context(IStudent)

     name = index.Field(attribute='name')


class StudentSearch(grok.View):
    grok.context(University)

    def update(self, query=None):
        self.search_result = []
        if query is not None:
            self.search_result = self.search_context(query)
            print "RESULT: ", list(self.search_result)

    def search_context(self, query):
        result = Query().searchResults(
            Eq(('students_catalog', 'name'), query)
            )
        return result
    
class ImportStudents(grok.View):
    grok.context(University)

    def render(self):
        t = [0]
        with accum_time(t):
            src = os.path.join(os.path.dirname(__file__), 'tests',
                               'results2.csv')
            inputfile = file(src, "r")
            num = 0
            headers, rows = readFile(inputfile)
            for i in rows:
                s = Student(i)
                self.context[str(num)] = s
                num += 1
        return "%s new Students added in %s" % (num, t[0])

class ListView(grok.View):
    grok.context(University)

    def render(self):
        result = []
        for s in self.context.values():
            result.append(getattr(s,'name', 'Error'+str(type(s))))
        return "\n".join(result)

import contextlib, time

class ExportStudents(grok.View):
    grok.context(University)
    
    def render(self):
        t = [0]
        with accum_time(t):
            result = []
            for s in self.context.values():
                result.append(s.getCsv())
            writeFile(result)
        return "yeah %s" % t[0]
        

def readFile(f):
    """read a CSV file"""
    headers = []
    rows = []
    f = csv.reader(f)
    headers = f.next()
    for line in f:
        rows.append(line)
    return (headers, rows)

def writeFile(data):
    writer = csv.writer(open("export.csv", "wb"))
    writer.writerows(data)

@contextlib.contextmanager
def accum_time(L):
  """
  Add time used inside a with block to the value of L[0].
  """
  start = time.clock()
  try:
    yield
  finally:
    end = time.clock()
    L[0] += end - start
